/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package net.ajaest.core.winHandlers;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;

import net.ajaest.core.main.JDKGUIEngine;
import net.ajaest.core.main.JDKOptions;
import net.ajaest.core.main.Messages;
import net.ajaest.data.kanji.KanjiTag;
import net.ajaest.data.kanji.Radical;
import net.ajaest.gui.auxi.KanjiInfoWindow;
import net.ajaest.gui.windows.KanjiInfoExtWindow;
import net.ajaest.gui.windows.KanjiInfoSimpleWindow;
import net.ajaest.gui.windows.RadicalInfoWindow;

/**
 *
 * @author ajaest10
 */
public class KanjiInfoWH implements WinHandler {

	// TODO: improve window positioning system
    private JDKGUIEngine jdkGui;
    
	private List<KanjiInfoWindow> displaying;

	private Dimension screen;
	private Point lastWindowPos;
	private int xShift = 140;
	private int yShift = 140;
	private int windowWidth = 584;
	private int windowLenght = 224;
	private int biggestXPos = 50000;
	@SuppressWarnings("unused")
	private int biggestYPos = 50000;

    public KanjiInfoWH(JDKGUIEngine jdkgui){
        this.jdkGui = jdkgui;
		displaying = new ArrayList<KanjiInfoWindow>();
		screen = Toolkit.getDefaultToolkit().getScreenSize();
    }

	public void invokeWindow(KanjiTag kt) {

        
            KanjiInfoWindow kif = null;

            if(jdkGui.getOptions().getExtendedInfo())
                kif = new KanjiInfoExtWindow(this, kt, jdkGui.getOptions().getRomanized());
            else
                kif = new KanjiInfoSimpleWindow(this, kt, jdkGui.getOptions().getRomanized());

            kif.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

		if (lastWindowPos == null)
			lastWindowPos = new Point(-xShift, 0);

		lastWindowPos.setLocation(lastWindowPos.getX() + xShift, lastWindowPos.getY());

		if (lastWindowPos.getX() + windowWidth > screen.width){
			lastWindowPos.setLocation(-xShift, lastWindowPos.getY() + yShift);
			biggestYPos = (int) lastWindowPos.getY();
			biggestXPos = (int) lastWindowPos.getX();
		}
		if (lastWindowPos.getY() + windowLenght > screen.height)
			lastWindowPos.setLocation(0, 0);

		kif.setLocation((int) lastWindowPos.getX(), (int) lastWindowPos.getY());

		kif.setVisible(true);

		displaying.add(kif);
    }

    public void radicalInfoButtonPressed(Integer classicRadical) {
        System.out.println("must show readical info");

        if(classicRadical!= null){
			SwingUtilities.invokeLater(new RadicalInfoWindow(this, jdkGui.getJavaDikt().getRadicalInfos(classicRadical)));
        }
    }

	public String getRadicalString(Integer rad) {

		String radString;
		if (rad != null) {
			Radical retRad = null;

			for (Radical r : jdkGui.getJavaDikt().getRadicalInfos(rad)) {
				if (r.getUnicode() != null) {
					retRad = r;
					break;
				}
			}

			if (retRad != null)
				radString = new String(Character.toChars(retRad.getUnicode()));
			else
				radString = rad.toString();
		} else 
			radString = "--";
			
		return radString;
    }

    public void windowClosed(KanjiInfoWindow kif) {


		int removedIndex = displaying.indexOf(kif);
		System.out.println("Window closed: " + removedIndex + "-" + displaying.size());
		if (removedIndex == displaying.size() - 1) {
			if (lastWindowPos.getX() < 0 && lastWindowPos.getY() > 0)
				lastWindowPos.setLocation(biggestXPos, lastWindowPos.getY() - yShift);
			else
				lastWindowPos.setLocation(lastWindowPos.getX() - xShift, lastWindowPos.getY());
		}

        displaying.remove(kif);
    }

    public JDKOptions getOptions() {
        return jdkGui.getOptions();
    }

    public String getMessage(String message){
        return Messages.get(message);
    }

	public List<Image> getIcons() {

		return jdkGui.getIcons();
	}

	public Font getUnicodeFont() {

		return jdkGui.getUnicodeFont();
	}

}
