//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.data.kanji;

import java.util.ArrayList;
import java.util.List;

//TODO: JavaDoc
public class Radical implements Comparable<Radical> {

	public Integer radicalNumber;
	public Integer auxNumber;

	public String unicodeName;
	public List<String> names;
	
	public Integer unicode;
	public Integer kangxiUnicode;

	public RadicalTypeEnum radicalType;
	
	public Radical(Integer radicalNumber) {
		this.radicalNumber = radicalNumber;
		this.names = new ArrayList<String>();
	}
	
	public Integer getAuxNumber() {
		return auxNumber;
	}

	public void setAuxNumber(Integer auxNumber) {
		this.auxNumber = auxNumber;
	}

	public String getUnicodeName() {
		return unicodeName;
	}

	public void setUnicodeName(String unicodeName) {
		this.unicodeName = unicodeName;
	}

	public List<String> getNames() {
		return names;
	}

	public void setNames(List<String> names) {
		this.names = names;
	}

	public Integer getUnicode() {
		return unicode;
	}

	public void setUnicode(Integer unicode) {
		this.unicode = unicode;
	}

	public Integer getKangxiUnicode() {
		return kangxiUnicode;
	}

	public void setKangxiUnicode(Integer kangxiUnicode) {
		this.kangxiUnicode = kangxiUnicode;
	}

	public RadicalTypeEnum getRadicalType() {
		return radicalType;
	}

	public void setRadicalType(RadicalTypeEnum radicalType) {
		this.radicalType = radicalType;
	}

	public Integer getRadicalNumber() {
		return radicalNumber;
	}

	public enum RadicalTypeEnum{
		original, top, bottom, left, right, enclosure, variable
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("Radical ");
		builder.append(radicalNumber);
		if (auxNumber != null) {
			builder.append(".");
			builder.append(auxNumber);
		}

		builder.append(" [kangxiUnicode=");
		builder.append(String.format("%x", kangxiUnicode));
		builder.append(", names=");
		builder.append(names);
		builder.append(", radicalType=");
		builder.append(radicalType);
		builder.append(", unicode=");
		builder.append(String.format("%x", unicode));
		builder.append(", unicodeName=");
		builder.append(unicodeName);
		builder.append("]");
		return builder.toString();
	}

	@Override
	public int compareTo(Radical o) {

		int compare = radicalNumber.compareTo(o.getRadicalNumber());

		if (compare == 0 && auxNumber != null && o.getAuxNumber() != null)
			compare = auxNumber.compareTo(o.getAuxNumber());

		return compare;
	}

}
