//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.gui.auxi;

import java.awt.Graphics;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;

import net.ajaest.core.main.Launcher;
import net.ajaest.data.auxi.Pair;

// TODO: Javadoc
public class JDrawPanel extends JPanel {
	// TODO: this class has a lot of redundant code. I think that in the future
	// it must be burn to ashes and be rebuild.
	/**
	 * 
	 */
	private static final long serialVersionUID = 7828389152957873184L;

	private LineDrawingMouseAdapter m;
	private LineDrawingKeyAdapter k;

	private List<Integer> x1 = new ArrayList<Integer>();
	private List<Integer> y1 = new ArrayList<Integer>();
	private List<Integer> x2 = new ArrayList<Integer>();
	private List<Integer> y2 = new ArrayList<Integer>();

	private List<Pair<Integer, Integer>> strokes = new ArrayList<Pair<Integer, Integer>>();

	private int tempX1, tempY1, tempX2, tempY2;

	public JDrawPanel() {

		m = new LineDrawingMouseAdapter(this);
		k = new LineDrawingKeyAdapter(this);
		addKeyListener(k);
		addMouseListener(m);
		addMouseWheelListener(m);
        }

	@Override
	public void paint(Graphics g) {
		super.paint(g);
		for (int i = 0; i < x1.size() - 1; i++)
			g.drawLine(x1.get(i), y1.get(i), x2.get(i), y2.get(i));
		if (tempX1 != -1 && tempY1 != -1 && tempX2 != -1 && tempY2 != -1)
			g.drawLine(tempX1, tempY1, tempX2, tempY2);
	}

	public boolean isMouseClicked() {
		return m.mouseClicked;
	}

	public void unclickMouse() {

		// TODO: WARNING! check if exists problem with strokes when unclick is
		// used or when last line is removed with scroll when it's being formed
		m.setMouseClicked(false);
		removeMouseMotionListener(m);

		// removes incomplete line
		if (x1.size() > x2.size()) {
			x1.remove(x1.size() - 1);
			y1.remove(y1.size() - 1);
		} else if (x1.size() < x2.size()) {
			// TODO: is this possible?
			x2.remove(x2.size() - 1);
			y2.remove(y2.size() - 1);
		}

		if (x1.size() > 0) {
			// chapuza! The last line is repainted using tempX and tempY
			setTempX1(getX1().get(getX1().size() - 1));
			setTempY1(getY1().get(getY1().size() - 1));
			setTempX2(getX2().get(getX2().size() - 1));
			setTempY2(getY2().get(getY2().size() - 1));
		}

		setStrokePoint();

		m.bufferX1 = new ArrayList<Integer>(getX1());
		m.bufferX2 = new ArrayList<Integer>(getX2());
		m.bufferY1 = new ArrayList<Integer>(getY1());
		m.bufferY2 = new ArrayList<Integer>(getY2());
		m.bufferStrokes = new ArrayList<Pair<Integer, Integer>>(strokes);
		m.savedStateValid = true;

		repaint();
	}

	public List<Pair<Integer, Integer>> getStrokes() {
		return strokes;
	}

	public JLineDraw getJLineDraw(){

		JLineDraw jld;
		if (x1.size() > 0 && y1.size() > 0 && x2.size() > 0 && y2.size() > 0)
			jld = new JLineDraw(x1, y1, x2, y2, strokes);
		else
			jld = null;
		return jld;
	}

	private void setTempX1(int tempX1) {
		this.tempX1 = tempX1;
	}

	private void setTempY1(int tempY1) {
		this.tempY1 = tempY1;
	}

	private void setTempX2(int tempX2) {
		this.tempX2 = tempX2;
	}

	private void setTempY2(int tempY2) {
		this.tempY2 = tempY2;
	}

	private List<Integer> getX1() {
		return x1;
	}

	private List<Integer> getY1() {
		return y1;
	}

	private List<Integer> getX2() {
		return x2;
	}

	private List<Integer> getY2() {
		return y2;
	}

	public void addLine(Integer x1, Integer y1, Integer x2, Integer y2) {

		this.x1.add(x1);
		this.x2.add(x2);
		this.y1.add(y1);
		this.y2.add(y2);
		tempX1 = -1;
		tempX2 = -1;
		tempY1 = -1;
		tempY2 = -1;
		repaint();
	}

	public void removeLastStroke() {

		if (strokes.size() > 0) {
			Pair<Integer, Integer> lastStroke = strokes.get(strokes.size() - 1);
			Integer removeLines = lastStroke.getSecond() - lastStroke.getFirst() + 1;

			for (int i = 0; i < removeLines; i++)
				removeLastLine();

			strokes.remove(lastStroke);
		}
	}

	public void removeLastLine() {
		removeMouseMotionListener(m);
		m.setMouseClicked(false);
		tempX1 = -1;
		tempX2 = -1;
		tempY1 = -1;
		tempY2 = -1;

		// deletes the last incomplete vector entry
		if (x1.size() > x2.size()) {
			x1.remove(x1.size() - 1);
			y1.remove(y1.size() - 1);
		} else if (x1.size() < x2.size()) {
			x2.remove(x2.size() - 1);
			y2.remove(y2.size() - 1);
		}

		// now all lists must have same size
		if (x1.size() > 0) {
			x1.remove(x1.size() - 1);
			x2.remove(x2.size() - 1);
			y1.remove(y1.size() - 1);
			y2.remove(y2.size() - 1);

			if (x1.size() > 0) {
				// chapuza! The last line is repainted using tempX and tempY
				setTempX1(getX1().get(getX1().size() - 1));
				setTempY1(getY1().get(getY1().size() - 1));
				setTempX2(getX2().get(getX2().size() - 1));
				setTempY2(getY2().get(getY2().size() - 1));
			}

			// rebuild stroke list
			if (strokes.size() != 0) {
				Pair<Integer, Integer> p = strokes.get(strokes.size() - 1);
				if (p.getFirst() > (x1.size() - 1))
					strokes.remove(p);
				else {
					// A new pair must be created in order to keep restore
					// buffer
					// integrity
					strokes.set(strokes.size() - 1, new Pair<Integer, Integer>(p.getFirst(), x1.size() - 1));
				}
			}
		}

		repaint();
	}

	public void reset() {

		unclickMouse();

		x1 = new ArrayList<Integer>();
		x2 = new ArrayList<Integer>();
		y1 = new ArrayList<Integer>();
		y2 = new ArrayList<Integer>();
		strokes = new ArrayList<Pair<Integer, Integer>>();
		tempX1 = -1;
		tempX2 = -1;
		tempY1 = -1;
		tempY2 = -1;
		removeMouseMotionListener(m);


		repaint();
	}

	private void setStrokePoint() {

		// first element of the pair is the beginning line of the stroke
		// and second element is the end of the stroke
		Pair<Integer, Integer> tempPair;

		if (strokes.size() == 0)
			strokes.add(new Pair<Integer, Integer>(x1.size() - 1, null));
		else {

			tempPair = strokes.get(strokes.size() - 1);

			if (tempPair.getSecond() == null) {
				tempPair.setSecond(x1.size() - 1);
			}
			else
				strokes.add(new Pair<Integer, Integer>(x1.size() - 1, null));
		}

	}

	private class LineDrawingKeyAdapter extends KeyAdapter {

		private JDrawPanel dp;

		public LineDrawingKeyAdapter(JDrawPanel dp) {
			this.dp = dp;
		}

		@Override
		public void keyPressed(KeyEvent k) {

			if (KeyEvent.getKeyText(k.getKeyCode()).equals("Escape")) {
				dp.reset();

			}
		}
	}

	private class LineDrawingMouseAdapter extends MouseAdapter {

		private List<Integer> bufferX1;// for backtracking
		private List<Integer> bufferY1;
		private List<Integer> bufferX2;
		private List<Integer> bufferY2;
		private List<Pair<Integer, Integer>> bufferStrokes;

		JDrawPanel dp;

		private boolean mouseClicked = false, savedStateValid = false;


		public boolean isMouseClicked() {
			return mouseClicked;
		}

		public void setMouseClicked(boolean mouseClicked) {
			this.mouseClicked = mouseClicked;
		}

		public LineDrawingMouseAdapter(JDrawPanel dp) {
			this.dp = dp;

		}

		@Override
		public void mouseWheelMoved(MouseWheelEvent w) {

			m.setMouseClicked(false);
			removeMouseMotionListener(m);

			// dp.setTempX1(-1);
			// dp.setTempX2(-1);
			// dp.setTempY1(-1);
			// dp.setTempY2(-1);

			// if (!savedStateValid) {
			//
			// // removes incomplete line
			// if (x1.size() > x2.size()) {
			// x1.remove(x1.size() - 1);
			// y1.remove(y1.size() - 1);
			// } else if (x1.size() < x2.size()) {
			// // TODO: is this possible?
			// x2.remove(x2.size() - 1);
			// y2.remove(y2.size() - 1);
			// }
			//
			// bufferX1 = new ArrayList<Integer>(dp.getX1());
			// bufferX2 = new ArrayList<Integer>(dp.getX2());
			// bufferY1 = new ArrayList<Integer>(dp.getY1());
			// bufferY2 = new ArrayList<Integer>(dp.getY2());
			// bufferStrokes = new ArrayList<Pair<Integer,
			// Integer>>(dp.strokes);
			// savedStateValid = true;
			//
			// }

			m.setMouseClicked(false);
			removeMouseMotionListener(m);

			int t = w.getWheelRotation();

			if (t > 0) {
				// WHEEL to user remove lines
				dp.removeLastLine();
				if (x1.size() > 0) {
					// chapuza! The last line is repainted using tempX and tempY
					dp.setTempX1(dp.getX1().get(dp.getX1().size() - 1));
					dp.setTempY1(dp.getY1().get(dp.getY1().size() - 1));
					dp.setTempX2(dp.getX2().get(dp.getX2().size() - 1));
					dp.setTempY2(dp.getY2().get(dp.getY2().size() - 1));
				}

			}

			else if (t < 0 && bufferX1.size() > dp.getX1().size()) {

				// WHEEL to the other side of the user restores lines
				dp.addLine(bufferX1.get(dp.x1.size()), bufferY1.get(dp.x1
						.size()), bufferX2.get(dp.x1.size()), bufferY2
						.get(dp.x1.size()));
				dp.setTempX1(dp.getX1().get(dp.getX1().size() - 1));
				dp.setTempY1(dp.getY1().get(dp.getY1().size() - 1));
				dp.setTempX2(dp.getX2().get(dp.getX2().size() - 1));
				dp.setTempY2(dp.getY2().get(dp.getY2().size() - 1));

				// stroke list must be restored manually
				if (dp.strokes.size() > 0){
					
					Pair<Integer, Integer> currentStroke = dp.strokes.get(dp.strokes.size() - 1);
					Pair<Integer, Integer> restoreStroke = bufferStrokes.get(dp.strokes.size() - 1);

					if(	(dp.getX1().size()-1) >= restoreStroke.getFirst() && 
						(dp.getX1().size()-1) <= restoreStroke.getSecond()){

						currentStroke.setSecond(currentStroke.getSecond()+1);
					} else {
						currentStroke = new Pair<Integer, Integer>(dp.getX1().size() - 1, dp.getX1().size() - 1);
						strokes.add(currentStroke);
					}
				} else {
					strokes.add(new Pair<Integer, Integer>(0, 0));
				}
			}

			dp.repaint();
		}

		@Override
		public void mouseMoved(MouseEvent me) {
			if (mouseClicked) {
				dp.setTempX2(me.getX());
				dp.setTempY2(me.getY());
				dp.repaint();
			}
		}

		@Override
		public void mouseClicked(MouseEvent me) {
			savedStateValid = false;
			if (me.getButton() == MouseEvent.BUTTON2) {
				dp.reset();
			}

			if (!mouseClicked && me.getButton() == MouseEvent.BUTTON1) {

				dp.setTempX1(me.getX());
				dp.setTempY1(me.getY());
				dp.getX1().add(me.getX());
				dp.getY1().add(me.getY());
				dp.addMouseMotionListener(this);
				mouseClicked = !mouseClicked;
				dp.setStrokePoint();

			} else if (mouseClicked && me.getButton() == MouseEvent.BUTTON3) {

				dp.removeMouseMotionListener(this);
				// dp.setTempX1(me.getX());
				// dp.setTempY1(me.getY());
				dp.getX2().add(me.getX());
				dp.getY2().add(me.getY());
				mouseClicked = !mouseClicked;
				dp.setStrokePoint();
				
				if (!savedStateValid) {

					// removes incomplete line
					if (x1.size() > x2.size()) {
						x1.remove(x1.size() - 1);
						y1.remove(y1.size() - 1);
					} else if (x1.size() < x2.size()) {
						// TODO: is this possible?
						x2.remove(x2.size() - 1);
						y2.remove(y2.size() - 1);
					}

					bufferX1 = new ArrayList<Integer>(dp.getX1());
					bufferX2 = new ArrayList<Integer>(dp.getX2());
					bufferY1 = new ArrayList<Integer>(dp.getY1());
					bufferY2 = new ArrayList<Integer>(dp.getY2());
					bufferStrokes = new ArrayList<Pair<Integer, Integer>>(dp.strokes);
					savedStateValid = true;

				}

			} else if (mouseClicked && (me.getButton() == MouseEvent.BUTTON1)) {

				dp.getX2().add(me.getX());
				dp.getY2().add(me.getY());
				dp.repaint();
				dp.setTempX1(me.getX());
				dp.setTempY1(me.getY());
				dp.getX1().add(me.getX());
				dp.getY1().add(me.getY());
			}

		}
	}

	public static void main(String... strings) {
		Launcher.main();
	}
}
