/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * KanjiInfoWindow.java
 *
 * Created on 12-nov-2010, 19:23:16
 */

package net.ajaest.gui.windows;

import net.ajaest.core.main.Messages;
import net.ajaest.core.winHandlers.KanjiInfoWH;
import net.ajaest.data.kanji.KanjiTag;
import net.ajaest.gui.auxi.JPanelFactory;
import net.ajaest.gui.auxi.KanjiInfoWindow;

/**
 *
 * @author ajaest10
 */
public class KanjiInfoSimpleWindow extends KanjiInfoWindow {

	private static final long serialVersionUID = 4223194232017462824L;


    /** Creates new form KanjiInfoWindow */
    public KanjiInfoSimpleWindow(KanjiInfoWH kimwh, KanjiTag kt, boolean romanized) {
        super(kimwh, kt, romanized);
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        SimpleKanjiInfoPanel = new javax.swing.JPanel();
        KanjiLiteralPanel = new javax.swing.JPanel();
        KanjiLiteralLabel = new javax.swing.JLabel();
        KanjiInfoPanel = new javax.swing.JPanel();
        RadicalTitle = new javax.swing.JPanel();
        RadicalTitleLabel = new javax.swing.JLabel();
        RadicalPanel = new javax.swing.JPanel();
        RadicalLabel = new javax.swing.JLabel();
        RadicalMoreInfoButton = new javax.swing.JButton();
        StrokeCountTitlePanel = new javax.swing.JPanel();
        StrokeCountTitleLabel = new javax.swing.JLabel();
        StrokeCountPanel = new javax.swing.JPanel();
        StrokeCountLabel = new javax.swing.JLabel();
        GradeTitlePanel = new javax.swing.JPanel();
        GradeTitleLabel = new javax.swing.JLabel();
        GradePanel = new javax.swing.JPanel();
        GradeLabel = new javax.swing.JLabel();
        KanjiMeaningPanel = new javax.swing.JPanel();
        MeaningsTitlePanel = new javax.swing.JPanel();
        MeaningsTitleLabel = new javax.swing.JLabel();
        MeaningsScrollPane = new javax.swing.JScrollPane();
        MeaningsList = new javax.swing.JList();
        KanjiReadingsPanel = new javax.swing.JPanel();
        ReadingsTitlePanel = new javax.swing.JPanel();
        ReadingsTitleLabel = new javax.swing.JLabel();
        ReadingsPanel = new javax.swing.JPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle(kt.toString());
        setIconImages(super.getIcons());
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
        });

        SimpleKanjiInfoPanel.setBackground(new java.awt.Color(122, 159, 168));
        SimpleKanjiInfoPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        KanjiLiteralPanel.setBackground(new java.awt.Color(254, 254, 254));
        KanjiLiteralPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        KanjiLiteralPanel.setLayout(new java.awt.BorderLayout());

        KanjiLiteralLabel.setFont(kimwh.getUnicodeFont().deriveFont((float)90));
        KanjiLiteralLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        KanjiLiteralLabel.setText(kt.toString());
        KanjiLiteralLabel.setAlignmentY(0.0F);
        KanjiLiteralLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        KanjiLiteralLabel.setMaximumSize(new java.awt.Dimension(80, 80));
        KanjiLiteralPanel.add(KanjiLiteralLabel, java.awt.BorderLayout.CENTER);

        KanjiInfoPanel.setBackground(new java.awt.Color(254, 254, 254));
        KanjiInfoPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        KanjiInfoPanel.setPreferredSize(new java.awt.Dimension(104, 104));

        RadicalTitle.setBackground(new java.awt.Color(145, 145, 145));

        RadicalTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        RadicalTitleLabel.setText(Messages.get(Messages.KANJI_CLASSIC_RADICAL));
        RadicalTitleLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout RadicalTitleLayout = new javax.swing.GroupLayout(RadicalTitle);
        RadicalTitle.setLayout(RadicalTitleLayout);
        RadicalTitleLayout.setHorizontalGroup(
            RadicalTitleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(RadicalTitleLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 132, Short.MAX_VALUE)
        );
        RadicalTitleLayout.setVerticalGroup(
            RadicalTitleLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(RadicalTitleLabel)
        );

        RadicalLabel.setFont(kimwh.getUnicodeFont());
        RadicalLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        RadicalLabel.setText(kimwh.getRadicalString(kt.getClassicRadical()));

        RadicalMoreInfoButton.setText("+");
        RadicalMoreInfoButton.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        RadicalMoreInfoButton.setMaximumSize(new java.awt.Dimension(23, 23));
        RadicalMoreInfoButton.setMinimumSize(new java.awt.Dimension(23, 23));
        RadicalMoreInfoButton.setPreferredSize(new java.awt.Dimension(23, 23));
        RadicalMoreInfoButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                RadicalMoreInfoButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout RadicalPanelLayout = new javax.swing.GroupLayout(RadicalPanel);
        RadicalPanel.setLayout(RadicalPanelLayout);
        RadicalPanelLayout.setHorizontalGroup(
            RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, RadicalPanelLayout.createSequentialGroup()
                .addContainerGap(50, Short.MAX_VALUE)
                .addComponent(RadicalLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 35, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(RadicalMoreInfoButton, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(6, 6, 6))
        );
        RadicalPanelLayout.setVerticalGroup(
            RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(RadicalPanelLayout.createSequentialGroup()
                .addGroup(RadicalPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(RadicalMoreInfoButton, javax.swing.GroupLayout.PREFERRED_SIZE, 17, Short.MAX_VALUE)
                    .addComponent(RadicalLabel))
                .addContainerGap())
        );

        StrokeCountTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        StrokeCountTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StrokeCountTitleLabel.setText(Messages.get(Messages.KANJI_STROKE_COUNT));
        StrokeCountTitleLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout StrokeCountTitlePanelLayout = new javax.swing.GroupLayout(StrokeCountTitlePanel);
        StrokeCountTitlePanel.setLayout(StrokeCountTitlePanelLayout);
        StrokeCountTitlePanelLayout.setHorizontalGroup(
            StrokeCountTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 132, Short.MAX_VALUE)
        );
        StrokeCountTitlePanelLayout.setVerticalGroup(
            StrokeCountTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountTitleLabel)
        );

        StrokeCountLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        StrokeCountLabel.setText(getStrokeCountString());

        javax.swing.GroupLayout StrokeCountPanelLayout = new javax.swing.GroupLayout(StrokeCountPanel);
        StrokeCountPanel.setLayout(StrokeCountPanelLayout);
        StrokeCountPanelLayout.setHorizontalGroup(
            StrokeCountPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountLabel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 132, Short.MAX_VALUE)
        );
        StrokeCountPanelLayout.setVerticalGroup(
            StrokeCountPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountLabel)
        );

        GradeTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        GradeTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        GradeTitleLabel.setText(Messages.get(Messages.KANJI_GRADE));

        javax.swing.GroupLayout GradeTitlePanelLayout = new javax.swing.GroupLayout(GradeTitlePanel);
        GradeTitlePanel.setLayout(GradeTitlePanelLayout);
        GradeTitlePanelLayout.setHorizontalGroup(
            GradeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 132, Short.MAX_VALUE)
        );
        GradeTitlePanelLayout.setVerticalGroup(
            GradeTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeTitleLabel)
        );

        GradeLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        GradeLabel.setText(getGradeString());

        javax.swing.GroupLayout GradePanelLayout = new javax.swing.GroupLayout(GradePanel);
        GradePanel.setLayout(GradePanelLayout);
        GradePanelLayout.setHorizontalGroup(
            GradePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(GradePanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(GradeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 108, Short.MAX_VALUE)
                .addContainerGap())
        );
        GradePanelLayout.setVerticalGroup(
            GradePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(GradeLabel)
        );

        javax.swing.GroupLayout KanjiInfoPanelLayout = new javax.swing.GroupLayout(KanjiInfoPanel);
        KanjiInfoPanel.setLayout(KanjiInfoPanelLayout);
        KanjiInfoPanelLayout.setHorizontalGroup(
            KanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(StrokeCountTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(GradeTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(RadicalTitle, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(RadicalPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(StrokeCountPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(GradePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        KanjiInfoPanelLayout.setVerticalGroup(
            KanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(KanjiInfoPanelLayout.createSequentialGroup()
                .addComponent(RadicalTitle, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(RadicalPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(StrokeCountTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(StrokeCountPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(GradeTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(GradePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        KanjiMeaningPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));

        MeaningsTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        MeaningsTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        MeaningsTitleLabel.setText(Messages.get(Messages.KANJI_MEANING));

        javax.swing.GroupLayout MeaningsTitlePanelLayout = new javax.swing.GroupLayout(MeaningsTitlePanel);
        MeaningsTitlePanel.setLayout(MeaningsTitlePanelLayout);
        MeaningsTitlePanelLayout.setHorizontalGroup(
            MeaningsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(MeaningsTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
        );
        MeaningsTitlePanelLayout.setVerticalGroup(
            MeaningsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(MeaningsTitleLabel)
        );

        MeaningsList.setBackground(new java.awt.Color(237, 236, 235));
        MeaningsList.setModel(getMeaningListModel());
        MeaningsScrollPane.setViewportView(MeaningsList);

        javax.swing.GroupLayout KanjiMeaningPanelLayout = new javax.swing.GroupLayout(KanjiMeaningPanel);
        KanjiMeaningPanel.setLayout(KanjiMeaningPanelLayout);
        KanjiMeaningPanelLayout.setHorizontalGroup(
            KanjiMeaningPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(MeaningsTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(MeaningsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 190, Short.MAX_VALUE)
        );
        KanjiMeaningPanelLayout.setVerticalGroup(
            KanjiMeaningPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(KanjiMeaningPanelLayout.createSequentialGroup()
                .addComponent(MeaningsTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(MeaningsScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 208, Short.MAX_VALUE))
        );

        KanjiReadingsPanel.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0), 3));
        KanjiReadingsPanel.setPreferredSize(new java.awt.Dimension(204, 40));

        ReadingsTitlePanel.setBackground(new java.awt.Color(145, 145, 145));

        ReadingsTitleLabel.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        ReadingsTitleLabel.setText(Messages.get(Messages.KANJI_READING));
        ReadingsTitleLabel.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);

        javax.swing.GroupLayout ReadingsTitlePanelLayout = new javax.swing.GroupLayout(ReadingsTitlePanel);
        ReadingsTitlePanel.setLayout(ReadingsTitlePanelLayout);
        ReadingsTitlePanelLayout.setHorizontalGroup(
            ReadingsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(ReadingsTitleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 212, Short.MAX_VALUE)
        );
        ReadingsTitlePanelLayout.setVerticalGroup(
            ReadingsTitlePanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(ReadingsTitleLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 16, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        ReadingsPanel.setLayout(new java.awt.BorderLayout());
        ReadingsPanel.add(JPanelFactory.createKanjiReadingsList(kimwh.getUnicodeFont(),kt, false, romanized));

        javax.swing.GroupLayout KanjiReadingsPanelLayout = new javax.swing.GroupLayout(KanjiReadingsPanel);
        KanjiReadingsPanel.setLayout(KanjiReadingsPanelLayout);
        KanjiReadingsPanelLayout.setHorizontalGroup(
            KanjiReadingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(ReadingsTitlePanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
            .addComponent(ReadingsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 212, Short.MAX_VALUE)
        );
        KanjiReadingsPanelLayout.setVerticalGroup(
            KanjiReadingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(KanjiReadingsPanelLayout.createSequentialGroup()
                .addComponent(ReadingsTitlePanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(ReadingsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 208, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout SimpleKanjiInfoPanelLayout = new javax.swing.GroupLayout(SimpleKanjiInfoPanel);
        SimpleKanjiInfoPanel.setLayout(SimpleKanjiInfoPanelLayout);
        SimpleKanjiInfoPanelLayout.setHorizontalGroup(
            SimpleKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(SimpleKanjiInfoPanelLayout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addGroup(SimpleKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(KanjiInfoPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE)
                    .addComponent(KanjiLiteralPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 138, Short.MAX_VALUE))
                .addGap(0, 0, 0)
                .addComponent(KanjiMeaningPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, 0)
                .addComponent(KanjiReadingsPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 218, Short.MAX_VALUE)
                .addGap(0, 0, 0))
        );
        SimpleKanjiInfoPanelLayout.setVerticalGroup(
            SimpleKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(SimpleKanjiInfoPanelLayout.createSequentialGroup()
                .addGroup(SimpleKanjiInfoPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(KanjiReadingsPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 230, Short.MAX_VALUE)
                    .addComponent(KanjiMeaningPanel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(SimpleKanjiInfoPanelLayout.createSequentialGroup()
                        .addComponent(KanjiLiteralPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 126, Short.MAX_VALUE)
                        .addGap(0, 0, 0)
                        .addComponent(KanjiInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 0, 0))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(0, 0, 0)
                .addComponent(SimpleKanjiInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 546, javax.swing.GroupLayout.PREFERRED_SIZE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(SimpleKanjiInfoPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void RadicalMoreInfoButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_RadicalMoreInfoButtonActionPerformed
        kimwh.radicalInfoButtonPressed(kt.getClassicRadical());
    }//GEN-LAST:event_RadicalMoreInfoButtonActionPerformed

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
        kimwh.windowClosed(this);
    }//GEN-LAST:event_formWindowClosed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel GradeLabel;
    private javax.swing.JPanel GradePanel;
    private javax.swing.JLabel GradeTitleLabel;
    private javax.swing.JPanel GradeTitlePanel;
    private javax.swing.JPanel KanjiInfoPanel;
    private javax.swing.JLabel KanjiLiteralLabel;
    private javax.swing.JPanel KanjiLiteralPanel;
    private javax.swing.JPanel KanjiMeaningPanel;
    private javax.swing.JPanel KanjiReadingsPanel;
    private javax.swing.JList MeaningsList;
    private javax.swing.JScrollPane MeaningsScrollPane;
    private javax.swing.JLabel MeaningsTitleLabel;
    private javax.swing.JPanel MeaningsTitlePanel;
    private javax.swing.JLabel RadicalLabel;
    private javax.swing.JButton RadicalMoreInfoButton;
    private javax.swing.JPanel RadicalPanel;
    private javax.swing.JPanel RadicalTitle;
    private javax.swing.JLabel RadicalTitleLabel;
    private javax.swing.JPanel ReadingsPanel;
    private javax.swing.JLabel ReadingsTitleLabel;
    private javax.swing.JPanel ReadingsTitlePanel;
    private javax.swing.JPanel SimpleKanjiInfoPanel;
    private javax.swing.JLabel StrokeCountLabel;
    private javax.swing.JPanel StrokeCountPanel;
    private javax.swing.JLabel StrokeCountTitleLabel;
    private javax.swing.JPanel StrokeCountTitlePanel;
    // End of variables declaration//GEN-END:variables

}
