//    Copyright (C) 2010  Luis Alfonso Arce González, ajaest[@]gmail.com
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

package net.ajaest.gui.windows;

import java.awt.BorderLayout;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import net.ajaest.core.main.Launcher;
import net.ajaest.core.main.Messages;
import net.ajaest.core.winHandlers.MainWH;
import net.ajaest.gui.auxi.JDrawPanel;

//TODO: javadoc
public class MainWindow extends javax.swing.JFrame {

	private static final long serialVersionUID = -8931522474874478538L;

	private MainWH mwh = null;

    
    /** Creates new form MainWindow */
	public MainWindow(MainWH mwh) {
        super();
		// TODO: this action must be performed by win handler
        this.mwh = mwh;
        initComponents();
		mwh.setWindow(this);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        ResultExportPanelControls = new javax.swing.JPanel();
        ResultExportPanelAll = new javax.swing.JButton();
        ResultExportPanelReset = new javax.swing.JButton();
        ResultExportPanelInvert = new javax.swing.JButton();
        ControlsTabbedPane = new javax.swing.JTabbedPane();
        DrawControlsTab = new javax.swing.JPanel();
        DrawPanel = new javax.swing.JPanel();
        DrawPanelControls = new javax.swing.JPanel();
        DrawPanelResetButton = new javax.swing.JButton();
        DrawPanelRemoveLastStrokeButton = new javax.swing.JButton();
        DrawPanelRemoveLastLine = new javax.swing.JButton();
        DrawQueryTableScrollPane = new javax.swing.JScrollPane();
        DrawQueryTable = new javax.swing.JTable();
        DrawQueryModifierPanel = new javax.swing.JPanel();
        DrawQueryModifierResetButton = new javax.swing.JButton();
        DrawQueryModifierRemoveButton = new javax.swing.JButton();
        DrawAndOrPanel = new javax.swing.JPanel();
        DrawAndButton = new javax.swing.JButton();
        DrawOrButton = new javax.swing.JButton();
        DrawExecuteButton = new javax.swing.JButton();
        CriteriaControlsTab = new javax.swing.JPanel();
        CriteriaQueryMakerTab = new javax.swing.JPanel();
        CriteriaQueryFieldComboBox = new javax.swing.JComboBox();
        CriteriaQueryFulfilsLabel = new javax.swing.JLabel();
        CriteriaQueryFulfilsComboBox = new javax.swing.JComboBox();
        CriteriaQueryValueComboBox = new javax.swing.JComboBox();
        CriteriaQueryMakerAndButton = new javax.swing.JButton();
        CriteriaQueryMakerOrButton = new javax.swing.JButton();
        CriteriaQueryDetailsCriteriaTab = new javax.swing.JPanel();
        CriteriaQueryTableScrollPane = new javax.swing.JScrollPane();
        CriteriaQueryTable = new javax.swing.JTable();
        CriteriaQueryControlsTab = new javax.swing.JPanel();
        CriteriaQueryModifierPanel = new javax.swing.JPanel();
        CriteriaQueryModifierResetButton = new javax.swing.JButton();
        CriteriaQueryModifierRemoveButton = new javax.swing.JButton();
        CriteriaQueryModifierModifyButton = new javax.swing.JButton();
        CriteriaQueryControlsExecuteButton = new javax.swing.JButton();
        ExportControlsTab = new javax.swing.JPanel();
        ExportAsPanel = new javax.swing.JPanel();
        ExportFormatLabel = new javax.swing.JLabel();
        ExportFormatComboBox = new javax.swing.JComboBox();
        ExportStyleLabel = new javax.swing.JLabel();
        ExportStyleComboBox = new javax.swing.JComboBox();
        ExportPathTextField = new javax.swing.JTextField();
        ExportChangePathButton = new javax.swing.JButton();
        ExportPathLabel = new javax.swing.JLabel();
        ExportSortingPanel = new javax.swing.JPanel();
        ExportSortingJScrollPane = new javax.swing.JScrollPane();
        ExportSortingTable = new javax.swing.JTable();
        ExportSortingResetButton = new javax.swing.JButton();
        ExportSortingRemoveButton = new javax.swing.JButton();
        ExportSortingAddButton = new javax.swing.JButton();
        ExportSortingExtraPanel = new javax.swing.JPanel();
        ExportSortingExtraRearrangeButton = new javax.swing.JButton();
        ExportSortingExtraMoreButton = new javax.swing.JButton();
        ExportButton = new javax.swing.JButton();
        OptionControlsTab = new javax.swing.JPanel();
        OptionLanguajeLabel = new javax.swing.JLabel();
        OptionLanguajeComboBox = new javax.swing.JComboBox();
        OptionKanjiDictPathLabel = new javax.swing.JLabel();
        OptionChangePathLabel = new javax.swing.JButton();
        OptionExtendedInfoCheckBox = new javax.swing.JCheckBox();
        OptionExtendedInfoLabel = new javax.swing.JLabel();
        OptionExtendedIKanjiListLabel = new javax.swing.JLabel();
        OptionExtendedIKanjiListCheckBox = new javax.swing.JCheckBox();
        OptionSaveButton = new javax.swing.JButton();
        OptionAboutButton = new javax.swing.JButton();
        OptionKanjiDictPathTextField = new javax.swing.JTextField();
        OptionKanaToRomajiLabel = new javax.swing.JLabel();
        OptionKanaToRomajiCheckBox = new javax.swing.JCheckBox();
        OptionChangeStrokesPathLabel = new javax.swing.JButton();
        OptionStrokesPathLabel = new javax.swing.JLabel();
        OptionStrokesPathTextField = new javax.swing.JTextField();
        ResultsPanel = new javax.swing.JPanel();
        ResultKanjiGrid = new javax.swing.JPanel();

        ResultExportPanelControls.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_RESULTS_EXPORT_BorderTextControls)));

        ResultExportPanelAll.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonExportAll));
        ResultExportPanelAll.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ResultExportPanelAllActionPerformed(evt);
            }
        });

        ResultExportPanelReset.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonExportReset));
        ResultExportPanelReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ResultExportPanelResetActionPerformed(evt);
            }
        });

        ResultExportPanelInvert.setText(mwh.getMessage(Messages.WINMAIN_RESULTS_ButtonExportInvert));
        ResultExportPanelInvert.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ResultExportPanelInvertActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ResultExportPanelControlsLayout = new javax.swing.GroupLayout(ResultExportPanelControls);
        ResultExportPanelControls.setLayout(ResultExportPanelControlsLayout);
        ResultExportPanelControlsLayout.setHorizontalGroup(
            ResultExportPanelControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ResultExportPanelControlsLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ResultExportPanelAll, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addComponent(ResultExportPanelReset, javax.swing.GroupLayout.DEFAULT_SIZE, 129, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(ResultExportPanelInvert, javax.swing.GroupLayout.PREFERRED_SIZE, 106, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18))
        );
        ResultExportPanelControlsLayout.setVerticalGroup(
            ResultExportPanelControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ResultExportPanelControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(ResultExportPanelAll)
                .addComponent(ResultExportPanelReset)
                .addComponent(ResultExportPanelInvert))
        );

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(mwh.getMessage(Messages.WINMAIN_name));
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setIconImages(mwh.getIcons());
        setResizable(false);
        getContentPane().setLayout(new java.awt.GridLayout(1, 2));

        ControlsTabbedPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        DrawControlsTab.setPreferredSize(new java.awt.Dimension(0, 0));

        DrawPanel.setBorder(new javax.swing.border.LineBorder(javax.swing.UIManager.getDefaults().getColor("dark"), 7, true));
        DrawPanel.setPreferredSize(new java.awt.Dimension(155, 155));
        DrawPanel.setLayout(new java.awt.BorderLayout());

        drawPanel = new JDrawPanel();
        drawPanel.setLayout(new java.awt.BorderLayout());
        JLabel backgroundImage = new JLabel(new ImageIcon("resources/images/drawGrid_150.png"));
        drawPanel.add(backgroundImage);

        //drawPanel.setOpaque(false);
        DrawPanel.add(drawPanel);

        DrawPanelControls.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_STROKES_BorderTextControls)));

        DrawPanelResetButton.setText(mwh.getMessage(Messages.WINMAIN_STROKES_ButtonDrawPanelReset));
        DrawPanelResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawPanelResetButtonActionPerformed(evt);
            }
        });

        DrawPanelRemoveLastStrokeButton.setText(mwh.getMessage(Messages.WINMAIN_STROKES_ButtonDrawPanelRemoveLastStroke));
        DrawPanelRemoveLastStrokeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawPanelRemoveLastStrokeButtonActionPerformed(evt);
            }
        });

        DrawPanelRemoveLastLine.setText(mwh.getMessage(Messages.WINMAIN_STROKES_ButtonDrawPanelRemoveLastLine));
        DrawPanelRemoveLastLine.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawPanelRemoveLastLineActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout DrawPanelControlsLayout = new javax.swing.GroupLayout(DrawPanelControls);
        DrawPanelControls.setLayout(DrawPanelControlsLayout);
        DrawPanelControlsLayout.setHorizontalGroup(
            DrawPanelControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawPanelControlsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(DrawPanelControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(DrawPanelResetButton, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                    .addComponent(DrawPanelRemoveLastLine, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE)
                    .addComponent(DrawPanelRemoveLastStrokeButton, javax.swing.GroupLayout.DEFAULT_SIZE, 171, Short.MAX_VALUE))
                .addContainerGap())
        );
        DrawPanelControlsLayout.setVerticalGroup(
            DrawPanelControlsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawPanelControlsLayout.createSequentialGroup()
                .addComponent(DrawPanelResetButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(DrawPanelRemoveLastLine)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(DrawPanelRemoveLastStrokeButton)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        DrawQueryTableScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryData)));
        DrawQueryTableScrollPane.setPreferredSize(new java.awt.Dimension(0, 0));

        DrawQueryTable.setFont(mwh.getUnicodeFont());
        DrawQueryTable.setModel(mwh.getQueryTableModel());
        DrawQueryTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        DrawQueryTable.setDefaultRenderer(Object.class, mwh.getQueryTableCellRenderer());
        DrawQueryTableScrollPane.setViewportView(DrawQueryTable);

        DrawQueryModifierPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryControls)));

        DrawQueryModifierResetButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlResetText));
        DrawQueryModifierResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawQueryModifierResetButtonActionPerformed(evt);
            }
        });

        DrawQueryModifierRemoveButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlRemoveText));
        DrawQueryModifierRemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawQueryModifierRemoveButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout DrawQueryModifierPanelLayout = new javax.swing.GroupLayout(DrawQueryModifierPanel);
        DrawQueryModifierPanel.setLayout(DrawQueryModifierPanelLayout);
        DrawQueryModifierPanelLayout.setHorizontalGroup(
            DrawQueryModifierPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawQueryModifierPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(DrawQueryModifierResetButton, javax.swing.GroupLayout.PREFERRED_SIZE, 173, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(DrawQueryModifierRemoveButton, javax.swing.GroupLayout.DEFAULT_SIZE, 147, Short.MAX_VALUE)
                .addContainerGap())
        );
        DrawQueryModifierPanelLayout.setVerticalGroup(
            DrawQueryModifierPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawQueryModifierPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(DrawQueryModifierResetButton)
                .addComponent(DrawQueryModifierRemoveButton))
        );

        DrawAndOrPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_STROKES_BorderTextAndOr)));

        DrawAndButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryMakerAddText));
        DrawAndButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawAndButtonActionPerformed(evt);
            }
        });

        DrawOrButton.setText(mwh.getMessage(Messages.WINMAIN_QUERY_DATA_cellOrString));
        DrawOrButton.setEnabled(false);
        DrawOrButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawOrButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout DrawAndOrPanelLayout = new javax.swing.GroupLayout(DrawAndOrPanel);
        DrawAndOrPanel.setLayout(DrawAndOrPanelLayout);
        DrawAndOrPanelLayout.setHorizontalGroup(
            DrawAndOrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawAndOrPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(DrawAndButton, javax.swing.GroupLayout.PREFERRED_SIZE, 65, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(DrawOrButton, javax.swing.GroupLayout.PREFERRED_SIZE, 48, Short.MAX_VALUE)
                .addContainerGap())
        );
        DrawAndOrPanelLayout.setVerticalGroup(
            DrawAndOrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawAndOrPanelLayout.createSequentialGroup()
                .addGroup(DrawAndOrPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(DrawAndButton)
                    .addComponent(DrawOrButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        DrawExecuteButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlExecuteText));
        DrawExecuteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                DrawExecuteButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout DrawControlsTabLayout = new javax.swing.GroupLayout(DrawControlsTab);
        DrawControlsTab.setLayout(DrawControlsTabLayout);
        DrawControlsTabLayout.setHorizontalGroup(
            DrawControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawControlsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(DrawControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, DrawControlsTabLayout.createSequentialGroup()
                        .addGroup(DrawControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(DrawAndOrPanel, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(DrawPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(DrawControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(DrawExecuteButton, javax.swing.GroupLayout.DEFAULT_SIZE, 207, Short.MAX_VALUE)
                            .addComponent(DrawPanelControls, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addComponent(DrawQueryModifierPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(DrawQueryTableScrollPane, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 368, Short.MAX_VALUE))
                .addContainerGap())
        );
        DrawControlsTabLayout.setVerticalGroup(
            DrawControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(DrawControlsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(DrawControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(DrawControlsTabLayout.createSequentialGroup()
                        .addComponent(DrawPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(DrawAndOrPanel, 0, 55, Short.MAX_VALUE))
                    .addGroup(DrawControlsTabLayout.createSequentialGroup()
                        .addComponent(DrawPanelControls, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(DrawExecuteButton, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addGap(0, 0, 0)
                .addComponent(DrawQueryTableScrollPane, javax.swing.GroupLayout.DEFAULT_SIZE, 95, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(DrawQueryModifierPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        ControlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Drawing), DrawControlsTab);

        CriteriaControlsTab.setPreferredSize(new java.awt.Dimension(0, 0));

        CriteriaQueryMakerTab.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryMaker)));
        CriteriaQueryMakerTab.setName("asd"); // NOI18N

        CriteriaQueryFieldComboBox.setModel(mwh.getCriteriaFieldComboBoxModel());
        CriteriaQueryFieldComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryFieldComboBoxActionPerformed(evt);
            }
        });

        CriteriaQueryFulfilsLabel.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_LabelFulfilsComboBox));

        CriteriaQueryFulfilsComboBox.setEnabled(false);

        CriteriaQueryValueComboBox.setEditable(true);
        CriteriaQueryValueComboBox.setFont(mwh.getUnicodeFont());
        CriteriaQueryValueComboBox.setEnabled(false);

        CriteriaQueryMakerAndButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryMakerAddText));
        CriteriaQueryMakerAndButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryMakerAndButtonActionPerformed(evt);
            }
        });

        CriteriaQueryMakerOrButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryMakerOrText));
        CriteriaQueryMakerOrButton.setEnabled(false);
        CriteriaQueryMakerOrButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryMakerOrButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout CriteriaQueryMakerTabLayout = new javax.swing.GroupLayout(CriteriaQueryMakerTab);
        CriteriaQueryMakerTab.setLayout(CriteriaQueryMakerTabLayout);
        CriteriaQueryMakerTabLayout.setHorizontalGroup(
            CriteriaQueryMakerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaQueryMakerTabLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(CriteriaQueryMakerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(CriteriaQueryValueComboBox, 0, 217, Short.MAX_VALUE)
                    .addComponent(CriteriaQueryFieldComboBox, 0, 217, Short.MAX_VALUE)
                    .addGroup(CriteriaQueryMakerTabLayout.createSequentialGroup()
                        .addComponent(CriteriaQueryFulfilsLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(CriteriaQueryFulfilsComboBox, 0, 111, Short.MAX_VALUE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(CriteriaQueryMakerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(CriteriaQueryMakerAndButton, javax.swing.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE)
                    .addComponent(CriteriaQueryMakerOrButton, javax.swing.GroupLayout.DEFAULT_SIZE, 109, Short.MAX_VALUE))
                .addContainerGap())
        );
        CriteriaQueryMakerTabLayout.setVerticalGroup(
            CriteriaQueryMakerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaQueryMakerTabLayout.createSequentialGroup()
                .addGroup(CriteriaQueryMakerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(CriteriaQueryMakerTabLayout.createSequentialGroup()
                        .addComponent(CriteriaQueryFieldComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(CriteriaQueryMakerTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(CriteriaQueryFulfilsComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(CriteriaQueryFulfilsLabel))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(CriteriaQueryValueComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(CriteriaQueryMakerTabLayout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(CriteriaQueryMakerAndButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(CriteriaQueryMakerOrButton)))
                .addContainerGap(6, Short.MAX_VALUE))
        );

        CriteriaQueryDetailsCriteriaTab.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryData)));
        CriteriaQueryDetailsCriteriaTab.setMinimumSize(new java.awt.Dimension(34, 1000));
        CriteriaQueryDetailsCriteriaTab.setPreferredSize(new java.awt.Dimension(0, 0));
        CriteriaQueryDetailsCriteriaTab.setLayout(new java.awt.BorderLayout());

        CriteriaQueryTableScrollPane.setPreferredSize(new java.awt.Dimension(0, 0));

        CriteriaQueryTable.setFont(mwh.getUnicodeFont());
        CriteriaQueryTable.setModel(mwh.getQueryTableModel());
        CriteriaQueryTable.setAutoResizeMode(javax.swing.JTable.AUTO_RESIZE_NEXT_COLUMN);
        CriteriaQueryTable.setDefaultRenderer(Object.class, mwh.getQueryTableCellRenderer());
        CriteriaQueryTableScrollPane.setViewportView(CriteriaQueryTable);

        CriteriaQueryDetailsCriteriaTab.add(CriteriaQueryTableScrollPane, java.awt.BorderLayout.CENTER);

        CriteriaQueryModifierPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_CRITERIA_BorderTextQueryControls)));

        CriteriaQueryModifierResetButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlResetText));
        CriteriaQueryModifierResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryModifierResetButtonActionPerformed(evt);
            }
        });

        CriteriaQueryModifierRemoveButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlRemoveText));
        CriteriaQueryModifierRemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryModifierRemoveButtonActionPerformed(evt);
            }
        });

        CriteriaQueryModifierModifyButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlModifyText));
        CriteriaQueryModifierModifyButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryModifierModifyButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout CriteriaQueryModifierPanelLayout = new javax.swing.GroupLayout(CriteriaQueryModifierPanel);
        CriteriaQueryModifierPanel.setLayout(CriteriaQueryModifierPanelLayout);
        CriteriaQueryModifierPanelLayout.setHorizontalGroup(
            CriteriaQueryModifierPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaQueryModifierPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(CriteriaQueryModifierResetButton, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(CriteriaQueryModifierRemoveButton, javax.swing.GroupLayout.DEFAULT_SIZE, 116, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(CriteriaQueryModifierModifyButton)
                .addContainerGap())
        );
        CriteriaQueryModifierPanelLayout.setVerticalGroup(
            CriteriaQueryModifierPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaQueryModifierPanelLayout.createSequentialGroup()
                .addGroup(CriteriaQueryModifierPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(CriteriaQueryModifierResetButton)
                    .addComponent(CriteriaQueryModifierRemoveButton)
                    .addComponent(CriteriaQueryModifierModifyButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        CriteriaQueryControlsExecuteButton.setText(mwh.getMessage(Messages.WINMAIN_CRITERIA_ButtonQueryControlExecuteText));
        CriteriaQueryControlsExecuteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                CriteriaQueryControlsExecuteButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout CriteriaQueryControlsTabLayout = new javax.swing.GroupLayout(CriteriaQueryControlsTab);
        CriteriaQueryControlsTab.setLayout(CriteriaQueryControlsTabLayout);
        CriteriaQueryControlsTabLayout.setHorizontalGroup(
            CriteriaQueryControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaQueryControlsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(CriteriaQueryControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(CriteriaQueryModifierPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(CriteriaQueryControlsExecuteButton, javax.swing.GroupLayout.DEFAULT_SIZE, 368, Short.MAX_VALUE)))
        );
        CriteriaQueryControlsTabLayout.setVerticalGroup(
            CriteriaQueryControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaQueryControlsTabLayout.createSequentialGroup()
                .addComponent(CriteriaQueryModifierPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(CriteriaQueryControlsExecuteButton, javax.swing.GroupLayout.DEFAULT_SIZE, 51, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout CriteriaControlsTabLayout = new javax.swing.GroupLayout(CriteriaControlsTab);
        CriteriaControlsTab.setLayout(CriteriaControlsTabLayout);
        CriteriaControlsTabLayout.setHorizontalGroup(
            CriteriaControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, CriteriaControlsTabLayout.createSequentialGroup()
                .addGroup(CriteriaControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(CriteriaQueryControlsTab, javax.swing.GroupLayout.Alignment.LEADING, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, CriteriaControlsTabLayout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(CriteriaControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(CriteriaQueryDetailsCriteriaTab, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 368, Short.MAX_VALUE)
                            .addComponent(CriteriaQueryMakerTab, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );
        CriteriaControlsTabLayout.setVerticalGroup(
            CriteriaControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(CriteriaControlsTabLayout.createSequentialGroup()
                .addComponent(CriteriaQueryMakerTab, javax.swing.GroupLayout.PREFERRED_SIZE, 123, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(CriteriaQueryDetailsCriteriaTab, javax.swing.GroupLayout.PREFERRED_SIZE, 139, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(CriteriaQueryControlsTab, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(24, 24, 24))
        );

        ControlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Criteria), CriteriaControlsTab);

        ExportControlsTab.setPreferredSize(new java.awt.Dimension(400, 400));

        ExportAsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_EXPORT_BorderTextExportAs)));

        ExportFormatLabel.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_LabelFormatComboBox));

        ExportFormatComboBox.setModel(mwh.getExportFormatModel());
        ExportFormatComboBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportFormatComboBoxActionPerformed(evt);
            }
        });

        ExportStyleLabel.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_LabelStyleComboBox));

        ExportStyleComboBox.setModel(mwh.getExportStyleModel());

        ExportChangePathButton.setText("...");
        ExportChangePathButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportChangePathButtonActionPerformed(evt);
            }
        });

        ExportPathLabel.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_LabelDirButton));

        javax.swing.GroupLayout ExportAsPanelLayout = new javax.swing.GroupLayout(ExportAsPanel);
        ExportAsPanel.setLayout(ExportAsPanelLayout);
        ExportAsPanelLayout.setHorizontalGroup(
            ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportAsPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(ExportPathLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(ExportStyleLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(ExportFormatLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(ExportAsPanelLayout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addComponent(ExportFormatComboBox, 0, 220, Short.MAX_VALUE))
                    .addGroup(ExportAsPanelLayout.createSequentialGroup()
                        .addGap(18, 18, 18)
                        .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(ExportStyleComboBox, 0, 220, Short.MAX_VALUE)
                            .addGroup(ExportAsPanelLayout.createSequentialGroup()
                                .addComponent(ExportChangePathButton)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(ExportPathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 187, Short.MAX_VALUE)))))
                .addContainerGap())
        );
        ExportAsPanelLayout.setVerticalGroup(
            ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportAsPanelLayout.createSequentialGroup()
                .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ExportFormatLabel)
                    .addComponent(ExportFormatComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ExportStyleLabel)
                    .addComponent(ExportStyleComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(6, 6, 6)
                .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ExportPathLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 28, Short.MAX_VALUE)
                    .addGroup(ExportAsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(ExportChangePathButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(ExportPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        ExportSortingPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_EXPORT_BorderTextExportSorting)));

        ExportSortingTable.setModel(mwh.getExportSorterTableModel());
        ExportSortingJScrollPane.setViewportView(ExportSortingTable);

        ExportSortingResetButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonSortingReset));
        ExportSortingResetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportSortingResetButtonActionPerformed(evt);
            }
        });

        ExportSortingRemoveButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonSortingRemove));
        ExportSortingRemoveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportSortingRemoveButtonActionPerformed(evt);
            }
        });

        ExportSortingAddButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonSortingAdd));
        ExportSortingAddButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportSortingAddButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ExportSortingPanelLayout = new javax.swing.GroupLayout(ExportSortingPanel);
        ExportSortingPanel.setLayout(ExportSortingPanelLayout);
        ExportSortingPanelLayout.setHorizontalGroup(
            ExportSortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, ExportSortingPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ExportSortingAddButton, javax.swing.GroupLayout.DEFAULT_SIZE, 106, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ExportSortingResetButton, javax.swing.GroupLayout.PREFERRED_SIZE, 108, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ExportSortingRemoveButton)
                .addContainerGap())
            .addGroup(ExportSortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(ExportSortingPanelLayout.createSequentialGroup()
                    .addContainerGap()
                    .addComponent(ExportSortingJScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 332, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );
        ExportSortingPanelLayout.setVerticalGroup(
            ExportSortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportSortingPanelLayout.createSequentialGroup()
                .addContainerGap(94, Short.MAX_VALUE)
                .addGroup(ExportSortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(ExportSortingRemoveButton)
                    .addComponent(ExportSortingResetButton)
                    .addComponent(ExportSortingAddButton)))
            .addGroup(ExportSortingPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(ExportSortingPanelLayout.createSequentialGroup()
                    .addComponent(ExportSortingJScrollPane, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(37, Short.MAX_VALUE)))
        );

        ExportSortingExtraPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_EXPORT_BorderTextExportExtra)));

        ExportSortingExtraRearrangeButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonExtraRearrange));
        ExportSortingExtraRearrangeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportSortingExtraRearrangeButtonActionPerformed(evt);
            }
        });

        ExportSortingExtraMoreButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonExtraOptions));
        ExportSortingExtraMoreButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportSortingExtraMoreButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ExportSortingExtraPanelLayout = new javax.swing.GroupLayout(ExportSortingExtraPanel);
        ExportSortingExtraPanel.setLayout(ExportSortingExtraPanelLayout);
        ExportSortingExtraPanelLayout.setHorizontalGroup(
            ExportSortingExtraPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportSortingExtraPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ExportSortingExtraPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ExportSortingExtraMoreButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(ExportSortingExtraRearrangeButton, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        ExportSortingExtraPanelLayout.setVerticalGroup(
            ExportSortingExtraPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportSortingExtraPanelLayout.createSequentialGroup()
                .addComponent(ExportSortingExtraRearrangeButton, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ExportSortingExtraMoreButton, javax.swing.GroupLayout.PREFERRED_SIZE, 16, Short.MAX_VALUE)
                .addContainerGap())
        );

        ExportButton.setText(mwh.getMessage(Messages.WINMAIN_EXPORT_ButtonExport));
        ExportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ExportButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout ExportControlsTabLayout = new javax.swing.GroupLayout(ExportControlsTab);
        ExportControlsTab.setLayout(ExportControlsTabLayout);
        ExportControlsTabLayout.setHorizontalGroup(
            ExportControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportControlsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(ExportControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ExportSortingPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, ExportControlsTabLayout.createSequentialGroup()
                        .addComponent(ExportSortingExtraPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(18, 18, 18)
                        .addComponent(ExportButton, javax.swing.GroupLayout.PREFERRED_SIZE, 208, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(ExportAsPanel, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        ExportControlsTabLayout.setVerticalGroup(
            ExportControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(ExportControlsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(ExportAsPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(ExportSortingPanel, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(ExportControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(ExportSortingExtraPanel, javax.swing.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE)
                    .addComponent(ExportButton, javax.swing.GroupLayout.DEFAULT_SIZE, 71, Short.MAX_VALUE))
                .addContainerGap())
        );

        ControlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Export), ExportControlsTab);

        OptionLanguajeLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelLanguajeComboBox));

        OptionLanguajeComboBox.setModel(mwh.getOptionLanguageComboBoxModel());

        OptionKanjiDictPathLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelKanjiFileTextField));

        OptionChangePathLabel.setText("...");
        OptionChangePathLabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OptionChangePathLabelActionPerformed(evt);
            }
        });

        OptionExtendedInfoLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelExtendedInfoCheckBox));

        OptionExtendedIKanjiListLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelExtendedKanjiListCheckBox));

        OptionSaveButton.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_ButtonSave));
        OptionSaveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OptionSaveButtonActionPerformed(evt);
            }
        });

        OptionAboutButton.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_ButtonAbout));
        OptionAboutButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OptionAboutButtonActionPerformed(evt);
            }
        });

        OptionKanjiDictPathTextField.setText("jTextField1");

        OptionKanaToRomajiLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelRomajiCheckBox));

        OptionChangeStrokesPathLabel.setText("...");
        OptionChangeStrokesPathLabel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                OptionChangeStrokesPathLabelActionPerformed(evt);
            }
        });

        OptionStrokesPathLabel.setText(mwh.getMessage(Messages.WINMAIN_OPTIONS_LabelStrokeFileTextField));

        OptionStrokesPathTextField.setText("jTextField1");

        javax.swing.GroupLayout OptionControlsTabLayout = new javax.swing.GroupLayout(OptionControlsTab);
        OptionControlsTab.setLayout(OptionControlsTabLayout);
        OptionControlsTabLayout.setHorizontalGroup(
            OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(OptionControlsTabLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(OptionControlsTabLayout.createSequentialGroup()
                        .addComponent(OptionLanguajeLabel)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(OptionLanguajeComboBox, 0, 262, Short.MAX_VALUE))
                    .addComponent(OptionKanjiDictPathLabel)
                    .addComponent(OptionStrokesPathLabel)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, OptionControlsTabLayout.createSequentialGroup()
                        .addComponent(OptionChangePathLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(OptionKanjiDictPathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 335, Short.MAX_VALUE))
                    .addGroup(OptionControlsTabLayout.createSequentialGroup()
                        .addComponent(OptionChangeStrokesPathLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(OptionStrokesPathTextField, javax.swing.GroupLayout.DEFAULT_SIZE, 335, Short.MAX_VALUE))
                    .addGroup(OptionControlsTabLayout.createSequentialGroup()
                        .addComponent(OptionSaveButton, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(18, 18, 18)
                        .addComponent(OptionAboutButton, javax.swing.GroupLayout.DEFAULT_SIZE, 169, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, OptionControlsTabLayout.createSequentialGroup()
                        .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(OptionKanaToRomajiLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE)
                            .addComponent(OptionExtendedInfoLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE)
                            .addComponent(OptionExtendedIKanjiListLabel, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 336, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                .addComponent(OptionExtendedIKanjiListCheckBox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(OptionExtendedInfoCheckBox))
                            .addComponent(OptionKanaToRomajiCheckBox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap())
        );
        OptionControlsTabLayout.setVerticalGroup(
            OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(OptionControlsTabLayout.createSequentialGroup()
                .addGap(32, 32, 32)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OptionLanguajeLabel)
                    .addComponent(OptionLanguajeComboBox, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(OptionKanjiDictPathLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(OptionChangePathLabel, 0, 0, Short.MAX_VALUE)
                    .addComponent(OptionKanjiDictPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addComponent(OptionStrokesPathLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(OptionChangeStrokesPathLabel, 0, 0, Short.MAX_VALUE)
                    .addComponent(OptionStrokesPathTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(OptionExtendedInfoCheckBox)
                    .addComponent(OptionExtendedInfoLabel))
                .addGap(12, 12, 12)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(OptionExtendedIKanjiListCheckBox)
                    .addComponent(OptionExtendedIKanjiListLabel))
                .addGap(18, 18, 18)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(OptionKanaToRomajiCheckBox)
                    .addComponent(OptionKanaToRomajiLabel))
                .addGap(11, 11, 11)
                .addGroup(OptionControlsTabLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(OptionSaveButton)
                    .addComponent(OptionAboutButton))
                .addGap(70, 70, 70))
        );

        ControlsTabbedPane.addTab(mwh.getMessage(Messages.WINMAIN_TAB_CONTROL_Config), OptionControlsTab);

        ChangeListener tabChanged = new ChangeListener() {
            public void stateChanged(ChangeEvent changeEvent) {
                JTabbedPane sourceTabbedPane = (JTabbedPane) changeEvent.getSource();
                int index = sourceTabbedPane.getSelectedIndex();
                mwh.tabChangedActionPerformed(index);
            }
        };
        ControlsTabbedPane.addChangeListener(tabChanged);

        getContentPane().add(ControlsTabbedPane);

        ResultsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(mwh.getMessage(Messages.WINMAIN_RESULTS_BorderTextResults)));
        ResultsPanel.setLayout(new java.awt.BorderLayout());

        ResultKanjiGrid.setFont(mwh.getUnicodeFont());

        javax.swing.GroupLayout ResultKanjiGridLayout = new javax.swing.GroupLayout(ResultKanjiGrid);
        ResultKanjiGrid.setLayout(ResultKanjiGridLayout);
        ResultKanjiGridLayout.setHorizontalGroup(
            ResultKanjiGridLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 388, Short.MAX_VALUE)
        );
        ResultKanjiGridLayout.setVerticalGroup(
            ResultKanjiGridLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 423, Short.MAX_VALUE)
        );

        ResultsPanel.add(ResultKanjiGrid, java.awt.BorderLayout.CENTER);

        getContentPane().add(ResultsPanel);

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-810)/2, (screenSize.height-480)/2, 810, 480);
    }// </editor-fold>//GEN-END:initComponents

	public javax.swing.JCheckBox getOptionExtendedIKanjiListCheckBox() {
		return OptionExtendedIKanjiListCheckBox;
	}

	public javax.swing.JCheckBox getOptionExtendedInfoCheckBox() {
		return OptionExtendedInfoCheckBox;
	}

	public javax.swing.JCheckBox getOptionKanaToRomajiCheckBox() {
		return OptionKanaToRomajiCheckBox;
	}

	public javax.swing.JTextField getOptionKanjiDictPathTextField() {
		return OptionKanjiDictPathTextField;
	}

	public javax.swing.JComboBox getOptionLanguajeComboBox() {
		return OptionLanguajeComboBox;
	}

	public javax.swing.JTextField getOptionStrokesPathTextField() {
		return OptionStrokesPathTextField;
	}
	public javax.swing.JComboBox getCriteriaQueryFieldComboBox() {
		return CriteriaQueryFieldComboBox;
	}

	public javax.swing.JComboBox getCriteriaQueryFulfilsComboBox() {
		return CriteriaQueryFulfilsComboBox;
	}

	public javax.swing.JComboBox getCriteriaQueryValueComboBox() {
		return CriteriaQueryValueComboBox;
	}

	public javax.swing.JButton getCriteriaQueryMakerAndButton() {
		return CriteriaQueryMakerAndButton;
	}

	public javax.swing.JButton getCriteriaQueryMakerOrButton() {
		return CriteriaQueryMakerOrButton;
	}

	private void CriteriaQueryControlsExecuteButtonActionPerformed(java.awt.event.ActionEvent evt) {// GEN-FIRST:event_CriteriaQueryControlsExecuteButtonActionPerformed
        mwh.executeQuery();
    }                                                                  

    private void ResultExportPanelAllActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ResultExportPanelAllActionPerformed
        mwh.exportResultPanelSelectAllButtonPressed();
    }//GEN-LAST:event_ResultExportPanelAllActionPerformed

    private void DrawExecuteButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawExecuteButtonActionPerformed
        mwh.executeDrawQuery();
    }//GEN-LAST:event_DrawExecuteButtonActionPerformed

    private void ExportChangePathButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportChangePathButtonActionPerformed
        mwh.changeExportPath();
    }//GEN-LAST:event_ExportChangePathButtonActionPerformed

    private void OptionChangePathLabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OptionChangePathLabelActionPerformed
        mwh.kanjiFileChoose();
    }//GEN-LAST:event_OptionChangePathLabelActionPerformed

    private void OptionSaveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OptionSaveButtonActionPerformed
        mwh.saveConfig();
    }//GEN-LAST:event_OptionSaveButtonActionPerformed

    private void OptionChangeStrokesPathLabelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OptionChangeStrokesPathLabelActionPerformed
        mwh.strokeFileChoose();
    }//GEN-LAST:event_OptionChangeStrokesPathLabelActionPerformed

    private void CriteriaQueryFieldComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriteriaQueryFieldComboBoxActionPerformed
		mwh.updateChoosableQueryComboBoxes();
    }//GEN-LAST:event_CriteriaQueryFieldComboBoxActionPerformed

    private void CriteriaQueryMakerAndButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriteriaQueryMakerAndButtonActionPerformed
		mwh.addAndQueryButtonPressed();
    }//GEN-LAST:event_CriteriaQueryMakerAndButtonActionPerformed

    private void CriteriaQueryMakerOrButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriteriaQueryMakerOrButtonActionPerformed
        mwh.orQueryButtonPressed();
    }//GEN-LAST:event_CriteriaQueryMakerOrButtonActionPerformed

    private void CriteriaQueryModifierResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriteriaQueryModifierResetButtonActionPerformed
        mwh.QueryModifierResetButtonPressed();
    }//GEN-LAST:event_CriteriaQueryModifierResetButtonActionPerformed

    private void CriteriaQueryModifierRemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriteriaQueryModifierRemoveButtonActionPerformed
        mwh.QueryModifierRemoveButtonPressed();
    }//GEN-LAST:event_CriteriaQueryModifierRemoveButtonActionPerformed

    private void CriteriaQueryModifierModifyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_CriteriaQueryModifierModifyButtonActionPerformed
        mwh.QueryModifierModifyButtonPressed();
    }//GEN-LAST:event_CriteriaQueryModifierModifyButtonActionPerformed

    private void DrawPanelResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawPanelResetButtonActionPerformed
        mwh.drawResetButtonPressed();
    }//GEN-LAST:event_DrawPanelResetButtonActionPerformed

    private void DrawPanelRemoveLastLineActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawPanelRemoveLastLineActionPerformed
        mwh.drawRemoveLastLineButtonPressed();
    }//GEN-LAST:event_DrawPanelRemoveLastLineActionPerformed

    private void DrawPanelRemoveLastStrokeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawPanelRemoveLastStrokeButtonActionPerformed
        mwh.drawRemoveLastStrokeButtonPressed();
    }//GEN-LAST:event_DrawPanelRemoveLastStrokeButtonActionPerformed

    private void DrawAndButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawAndButtonActionPerformed
        mwh.drawAndButtonPressed();
    }//GEN-LAST:event_DrawAndButtonActionPerformed

    private void DrawQueryModifierResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawQueryModifierResetButtonActionPerformed
        mwh.QueryModifierResetButtonPressed();
    }//GEN-LAST:event_DrawQueryModifierResetButtonActionPerformed

    private void DrawQueryModifierRemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawQueryModifierRemoveButtonActionPerformed
        mwh.QueryModifierRemoveButtonPressed();
    }//GEN-LAST:event_DrawQueryModifierRemoveButtonActionPerformed

    private void DrawOrButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_DrawOrButtonActionPerformed
        mwh.drawOrButtonPressed();
    }//GEN-LAST:event_DrawOrButtonActionPerformed

    private void ExportFormatComboBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportFormatComboBoxActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ExportFormatComboBoxActionPerformed

    private void ExportSortingExtraMoreButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportSortingExtraMoreButtonActionPerformed
        mwh.exportMoreButtonPressed();
    }//GEN-LAST:event_ExportSortingExtraMoreButtonActionPerformed

    private void ResultExportPanelResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ResultExportPanelResetActionPerformed
        mwh.exportResultPanelResetButtonPressed();
    }//GEN-LAST:event_ResultExportPanelResetActionPerformed

    private void ResultExportPanelInvertActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ResultExportPanelInvertActionPerformed
        mwh.exportResultPanelInvertButtonPressed();
    }//GEN-LAST:event_ResultExportPanelInvertActionPerformed

    private void ExportSortingExtraRearrangeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportSortingExtraRearrangeButtonActionPerformed
        mwh.exportRearrangeButtonPressed();
    }//GEN-LAST:event_ExportSortingExtraRearrangeButtonActionPerformed

    private void ExportSortingAddButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportSortingAddButtonActionPerformed
        mwh.exportSorterAddButtonPressed();
}//GEN-LAST:event_ExportSortingAddButtonActionPerformed

    private void ExportSortingResetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportSortingResetButtonActionPerformed
        mwh.exportSorterResetButtonPressed();
    }//GEN-LAST:event_ExportSortingResetButtonActionPerformed

    private void ExportSortingRemoveButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportSortingRemoveButtonActionPerformed
        mwh.exportSorterRemoveButtonPressed();
    }//GEN-LAST:event_ExportSortingRemoveButtonActionPerformed

    private void ExportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ExportButtonActionPerformed
        mwh.exportExportButtonPressed();
    }//GEN-LAST:event_ExportButtonActionPerformed

    private void OptionAboutButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OptionAboutButtonActionPerformed
        mwh.optionsAboutButtonPressed();
    }//GEN-LAST:event_OptionAboutButtonActionPerformed

    public JPanel getResultPanel(){
        return ResultsPanel;
    }


    public JPanel getExportControlsJPanel(){

        return ResultExportPanelControls;
    }

	public JScrollPane getBufferedKanjiInfoGrid() {

		return kanjiInfoGridBuffer;
	}

	public JScrollPane getBufferedKanjiExportGrid() {

		return kanjiExportGridBuffer;
	}

	public void setBufferedKanjiInfoGrid(JScrollPane kanjiInfo) {

		this.kanjiInfoGridBuffer = kanjiInfo;
	}

	public void setBufferedKanjiExportGrid(JScrollPane kanjiExport) {

		// TODO: maybe this action should be performed by win handler
		this.kanjiExportGridBuffer = kanjiExport;
		exportPanel = new JPanel();
		exportPanel.setLayout(new BorderLayout());
		exportPanel.add(ResultExportPanelControls, BorderLayout.SOUTH);

		exportPanel.add(kanjiExportGridBuffer, BorderLayout.CENTER);
	}

	public JPanel getExportPanelControls() {

		return ResultExportPanelControls;
	}
	public JPanel getExportPanel() {
		return exportPanel;
	}

	public void setExportPanel(JPanel exportPanel) {
		this.exportPanel = exportPanel;
	}

	public JPanel getOptionControlsTab() {

		return OptionControlsTab;
	}

	public javax.swing.JTable getCriteriaQueryTable() {
		return CriteriaQueryTable;
	}

	public javax.swing.JTabbedPane getControlsTabbedPane() {
		return ControlsTabbedPane;
	}
	public javax.swing.JButton getDrawExecuteButton() {
		return DrawExecuteButton;
	}

	public javax.swing.JPanel getDrawQueryModifierPanel() {
		return DrawQueryModifierPanel;
	}

	public javax.swing.JButton getDrawQueryModifierRemoveButton() {
		return DrawQueryModifierRemoveButton;
	}

	public javax.swing.JButton getDrawQueryModifierResetButton() {
		return DrawQueryModifierResetButton;
	}

	public javax.swing.JButton getCriteriaQueryControlsExecuteButton() {
		return CriteriaQueryControlsExecuteButton;
	}

	public javax.swing.JButton getCriteriaQueryModifierModifyButton() {
		return CriteriaQueryModifierModifyButton;
	}

	public javax.swing.JButton getCriteriaQueryModifierRemoveButton() {
		return CriteriaQueryModifierRemoveButton;
	}

	public javax.swing.JButton getCriteriaQueryModifierResetButton() {
		return CriteriaQueryModifierResetButton;
	}

	public javax.swing.JTable getDrawQueryTable() {
		return DrawQueryTable;
	}
	public javax.swing.JButton getDrawAndButton() {
		return DrawAndButton;
	}

	public javax.swing.JButton getDrawOrButton() {
		return DrawOrButton;
	}

	public JDrawPanel getDrawPanel() {
		return drawPanel;
	}

	public javax.swing.JComboBox getExportFormatComboBox() {
		return ExportFormatComboBox;
	}

	public javax.swing.JComboBox getExportStyleComboBox() {
		return ExportStyleComboBox;
	}

	public javax.swing.JPanel getExportControlsTab() {
		return ExportControlsTab;
	}

	public javax.swing.JTextField getExportPathTextField() {
		return ExportPathTextField;
	}

	public JTable getExportSortingTable() {

		return ExportSortingTable;
	}

	/**
	 * @param args
	 *            the command line arguments
	 */
    public static void main(String args[]) {

		Launcher.main();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane ControlsTabbedPane;
    private javax.swing.JPanel CriteriaControlsTab;
    private javax.swing.JButton CriteriaQueryControlsExecuteButton;
    private javax.swing.JPanel CriteriaQueryControlsTab;
    private javax.swing.JPanel CriteriaQueryDetailsCriteriaTab;
    private javax.swing.JComboBox CriteriaQueryFieldComboBox;
    private javax.swing.JComboBox CriteriaQueryFulfilsComboBox;
    private javax.swing.JLabel CriteriaQueryFulfilsLabel;
    private javax.swing.JButton CriteriaQueryMakerAndButton;
    private javax.swing.JButton CriteriaQueryMakerOrButton;
    private javax.swing.JPanel CriteriaQueryMakerTab;
    private javax.swing.JButton CriteriaQueryModifierModifyButton;
    private javax.swing.JPanel CriteriaQueryModifierPanel;
    private javax.swing.JButton CriteriaQueryModifierRemoveButton;
    private javax.swing.JButton CriteriaQueryModifierResetButton;
    private javax.swing.JTable CriteriaQueryTable;
    private javax.swing.JScrollPane CriteriaQueryTableScrollPane;
    private javax.swing.JComboBox CriteriaQueryValueComboBox;
    private javax.swing.JButton DrawAndButton;
    private javax.swing.JPanel DrawAndOrPanel;
    private javax.swing.JPanel DrawControlsTab;
    private javax.swing.JButton DrawExecuteButton;
    private javax.swing.JButton DrawOrButton;
    private javax.swing.JPanel DrawPanel;
    private javax.swing.JPanel DrawPanelControls;
    private javax.swing.JButton DrawPanelRemoveLastLine;
    private javax.swing.JButton DrawPanelRemoveLastStrokeButton;
    private javax.swing.JButton DrawPanelResetButton;
    private javax.swing.JPanel DrawQueryModifierPanel;
    private javax.swing.JButton DrawQueryModifierRemoveButton;
    private javax.swing.JButton DrawQueryModifierResetButton;
    private javax.swing.JTable DrawQueryTable;
    private javax.swing.JScrollPane DrawQueryTableScrollPane;
    private javax.swing.JPanel ExportAsPanel;
    private javax.swing.JButton ExportButton;
    private javax.swing.JButton ExportChangePathButton;
    private javax.swing.JPanel ExportControlsTab;
    private javax.swing.JComboBox ExportFormatComboBox;
    private javax.swing.JLabel ExportFormatLabel;
    private javax.swing.JLabel ExportPathLabel;
    private javax.swing.JTextField ExportPathTextField;
    private javax.swing.JButton ExportSortingAddButton;
    private javax.swing.JButton ExportSortingExtraMoreButton;
    private javax.swing.JPanel ExportSortingExtraPanel;
    private javax.swing.JButton ExportSortingExtraRearrangeButton;
    private javax.swing.JScrollPane ExportSortingJScrollPane;
    private javax.swing.JPanel ExportSortingPanel;
    private javax.swing.JButton ExportSortingRemoveButton;
    private javax.swing.JButton ExportSortingResetButton;
    private javax.swing.JTable ExportSortingTable;
    private javax.swing.JComboBox ExportStyleComboBox;
    private javax.swing.JLabel ExportStyleLabel;
    private javax.swing.JButton OptionAboutButton;
    private javax.swing.JButton OptionChangePathLabel;
    private javax.swing.JButton OptionChangeStrokesPathLabel;
    private javax.swing.JPanel OptionControlsTab;
    private javax.swing.JCheckBox OptionExtendedIKanjiListCheckBox;
    private javax.swing.JLabel OptionExtendedIKanjiListLabel;
    private javax.swing.JCheckBox OptionExtendedInfoCheckBox;
    private javax.swing.JLabel OptionExtendedInfoLabel;
    private javax.swing.JCheckBox OptionKanaToRomajiCheckBox;
    private javax.swing.JLabel OptionKanaToRomajiLabel;
    private javax.swing.JLabel OptionKanjiDictPathLabel;
    private javax.swing.JTextField OptionKanjiDictPathTextField;
    private javax.swing.JComboBox OptionLanguajeComboBox;
    private javax.swing.JLabel OptionLanguajeLabel;
    private javax.swing.JButton OptionSaveButton;
    private javax.swing.JLabel OptionStrokesPathLabel;
    private javax.swing.JTextField OptionStrokesPathTextField;
    private javax.swing.JButton ResultExportPanelAll;
    private javax.swing.JPanel ResultExportPanelControls;
    private javax.swing.JButton ResultExportPanelInvert;
    private javax.swing.JButton ResultExportPanelReset;
    private javax.swing.JPanel ResultKanjiGrid;
    private javax.swing.JPanel ResultsPanel;
    // End of variables declaration//GEN-END:variables
    
	private JScrollPane kanjiInfoGridBuffer = null;
	private JScrollPane kanjiExportGridBuffer = null;
	private JPanel exportPanel = null;
	private JDrawPanel drawPanel = null;
}
